#include <zephyr/zephyr.h>

#include <logging/log.h>
LOG_MODULE_REGISTER(flash_test, LOG_LEVEL_INF);

#include <hal/nrf_nvmc.h>

#define NRF_NVMC_APP_CORE_S	((NRF_NVMC_Type*) 0x50039000UL)

static void nvmc_word_write(uint32_t address, uint32_t value)
{
	nrf_nvmc_mode_set(NRF_NVMC_APP_CORE_S, NRF_NVMC_MODE_WRITE);

	while (!nrf_nvmc_ready_check(NRF_NVMC_APP_CORE_S))
	{}

	*(volatile uint32_t *)address = value;
	__DMB();

	nrf_nvmc_mode_set(NRF_NVMC_APP_CORE_S, NRF_NVMC_MODE_READONLY);
}

void main(void)
{
	LOG_INF("\n\n***Start***");

	k_sleep(K_SECONDS(2));

	nvmc_word_write(0x80000, 0xaa);

	while (1) {
		k_sleep(K_MSEC(1000));
	}
}
